opennlp.tools.util.featuregen

## Class WindowFeatureGenerator

- java.lang.Object
- - opennlp.tools.util.featuregen.WindowFeatureGenerator

- All Implemented Interfaces:
    AdaptiveFeatureGenerator

      public class WindowFeatureGenerator
      extends Object
      implements AdaptiveFeatureGenerator

  Generates previous and next features for a given `AdaptiveFeatureGenerator`. The window size can be specified. Features: Current token is always included unchanged Previous tokens are prefixed with p distance Next tokens are prefix with n distance

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `NEXT_PREFIX`
    `static String` | `PREV_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `WindowFeatureGenerator(AdaptiveFeatureGenerator... generators)` Initializes the current instance with the given parameters.
    `WindowFeatureGenerator(AdaptiveFeatureGenerator generator)` Initializes the current instance.
    `WindowFeatureGenerator(AdaptiveFeatureGenerator generator, int prevWindowSize, int nextWindowSize)` Initializes the current instance with the given parameters.
    `WindowFeatureGenerator(int prevWindowSize, int nextWindowSize, AdaptiveFeatureGenerator... generators)` Initializes the current instance with the given parameters.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clearAdaptiveData()` Informs the feature generator that the context of the adaptive data (typically a document) is no longer valid.
    `void` | `createFeatures(List<String> features, String[] tokens, int index, String[] preds)` Adds the appropriate features for the token at the specified index with the specified array of previous outcomes to the specified list of features.
    `String` | `toString()`
    `void` | `updateAdaptiveData(String[] tokens, String[] outcomes)` Informs the feature generator that the specified tokens have been classified with the corresponding set of specified outcomes.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### PREV_PREFIX

          public static final String PREV_PREFIX

      See Also:
        Constant Field Values

    - #### NEXT_PREFIX

          public static final String NEXT_PREFIX

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### WindowFeatureGenerator

          public WindowFeatureGenerator(AdaptiveFeatureGenerator generator,
                                        int prevWindowSize,
                                        int nextWindowSize)

      Initializes the current instance with the given parameters.
      Parameters:
        `generator` - Feature generator to apply to the window.
        `prevWindowSize` - Size of the window to the left of the current token.
        `nextWindowSize` - Size of the window to the right of the current token.

    - #### WindowFeatureGenerator

          public WindowFeatureGenerator(int prevWindowSize,
                                        int nextWindowSize,
                                        AdaptiveFeatureGenerator... generators)

      Initializes the current instance with the given parameters.
      Parameters:
        `prevWindowSize` -
        `nextWindowSize` -
        `generators` -

    - #### WindowFeatureGenerator

          public WindowFeatureGenerator(AdaptiveFeatureGenerator generator)

      Initializes the current instance. The previous and next window size is 5.
      Parameters:
        `generator` - feature generator

    - #### WindowFeatureGenerator

          public WindowFeatureGenerator(AdaptiveFeatureGenerator... generators)

      Initializes the current instance with the given parameters.
      Parameters:
        `generators` - array of feature generators

  - ### Method Detail

    - #### createFeatures

          public void createFeatures(List<String> features,
                                     String[] tokens,
                                     int index,
                                     String[] preds)

      Description copied from interface: `AdaptiveFeatureGenerator`
      Adds the appropriate features for the token at the specified index with the specified array of previous outcomes to the specified list of features.
      Specified by:
        `createFeatures` in interface `AdaptiveFeatureGenerator`
      Parameters:
        `features` - The list of features to be added to.
        `tokens` - The tokens of the sentence or other text unit being processed.
        `index` - The index of the token which is currently being processed.
        `preds` - The outcomes for the tokens prior to the specified index.

    - #### updateAdaptiveData

          public void updateAdaptiveData(String[] tokens,
                                         String[] outcomes)

      Description copied from interface: `AdaptiveFeatureGenerator`
      Informs the feature generator that the specified tokens have been classified with the corresponding set of specified outcomes.
      Specified by:
        `updateAdaptiveData` in interface `AdaptiveFeatureGenerator`
      Parameters:
        `tokens` - The tokens of the sentence or other text unit which has been processed.
        `outcomes` - The outcomes associated with the specified tokens.

    - #### clearAdaptiveData

          public void clearAdaptiveData()

      Description copied from interface: `AdaptiveFeatureGenerator`
      Informs the feature generator that the context of the adaptive data (typically a document) is no longer valid.
      Specified by:
        `clearAdaptiveData` in interface `AdaptiveFeatureGenerator`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2026 The Apache Software Foundation. All rights reserved.